Index: trunk/kernel/fs/vfs.c
===================================================================
--- trunk/kernel/fs/vfs.c	(revision 437)
+++ trunk/kernel/fs/vfs.c	(revision 438)
@@ -157,7 +157,7 @@
     error_t            error;
 
-#if CONFIG_DEBUG_VFS_INODE_CREATE
+#if DEBUG_VFS_INODE_CREATE
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_INODE_CREATE < cycle )
+if( DEBUG_VFS_INODE_CREATE < cycle )
 printk("\n[DBG] %s : thread %x enter / dentry = %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, GET_PTR(dentry_xp), GET_CXY(dentry_xp), cycle );
@@ -234,7 +234,7 @@
     remote_spinlock_init( XPTR( local_cxy , &inode->main_lock ) );
 
-#if CONFIG_DEBUG_VFS_INODE_CREATE
+#if DEBUG_VFS_INODE_CREATE
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_INODE_CREATE < cycle )
+if( DEBUG_VFS_INODE_CREATE < cycle )
 printk("\n[DBG] %s : thread %x exit / inode = %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, inode, local_cxy, cycle );
@@ -272,7 +272,7 @@
 {
 
-#if CONFIG_DEBUG_VFS_INODE_LOAD
+#if DEBUG_VFS_INODE_LOAD
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_INODE_LOAD < cycle )
+if( DEBUG_VFS_INODE_LOAD < cycle )
 printk("\n[DBG] %s : thread %x enter for <%s> / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD , name , cycle );
@@ -306,7 +306,7 @@
     }
 
-#if CONFIG_DEBUG_VFS_INODE_LOAD
+#if DEBUG_VFS_INODE_LOAD
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_INODE_LOAD < cycle )
+if( DEBUG_VFS_INODE_LOAD < cycle )
 printk("\n[DBG] %s : thread %x exit for <%s> / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD , name , cycle );
@@ -433,7 +433,7 @@
 	kmem_req_t       req;        // request to kernel memory allocator
 
-#if CONFIG_DEBUG_VFS_DENTRY_CREATE
+#if DEBUG_VFS_DENTRY_CREATE
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_DENTRY_CREATE < cycle )
+if( DEBUG_VFS_DENTRY_CREATE < cycle )
 printk("\n[DBG] %s : thread %x enter for <%s> / parent_inode %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD , name , parent , cycle );
@@ -456,5 +456,5 @@
     {
 
-#if CONFIG_DEBUG_SYSCALLS_ERROR
+#if DEBUG_SYSCALLS_ERROR
 printk("\n[ERROR] in %s : name <name> too long\n", __FUNCTION__ , name );
 #endif
@@ -471,5 +471,5 @@
     {
 
-#if CONFIG_DEBUG_SYSCALLS_ERROR
+#if DEBUG_SYSCALLS_ERROR
 printk("\n[ERROR] in %s : cannot allocate dentry\n", __FUNCTION__ );
 #endif
@@ -484,7 +484,7 @@
     strcpy( dentry->name , name );
 
-#if( CONFIG_DEBUG_VFS_DENTRY_CREATE & 1 )
+#if( DEBUG_VFS_DENTRY_CREATE & 1 )
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_DENTRY_CREATE < cycle )
+if( DEBUG_VFS_DENTRY_CREATE < cycle )
 printk("\n[DBG] %s : dentry initialised\n", __FUNCTION__ );
 #endif
@@ -495,7 +495,7 @@
                   XPTR( local_cxy , &dentry->list ) );
 
-#if( CONFIG_DEBUG_VFS_DENTRY_CREATE & 1 )
+#if( DEBUG_VFS_DENTRY_CREATE & 1 )
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_DENTRY_CREATE < cycle )
+if( DEBUG_VFS_DENTRY_CREATE < cycle )
 printk("\n[DBG] %s : dentry registerd in htab\n", __FUNCTION__ );
 #endif
@@ -504,7 +504,7 @@
     *dentry_xp = XPTR( local_cxy , dentry );
 
-#if CONFIG_DEBUG_VFS_DENTRY_CREATE
+#if DEBUG_VFS_DENTRY_CREATE
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_DENTRY_CREATE < cycle )
+if( DEBUG_VFS_DENTRY_CREATE < cycle )
 printk("\n[DBG] %s : thread %x exit for <%s> / dentry %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD , name , dentry , cycle );
@@ -627,7 +627,7 @@
     uint32_t      file_id;      // created file descriptor index in reference fd_array
 
-#if CONFIG_DEBUG_VFS_OPEN
+#if DEBUG_VFS_OPEN
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_OPEN < cycle )
+if( DEBUG_VFS_OPEN < cycle )
 printk("\n[DBG] %s :  thread %x enter for <%s> / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, path, cycle );
@@ -674,7 +674,7 @@
     if( error ) return error;
 
-#if CONFIG_DEBUG_VFS_OPEN
+#if DEBUG_VFS_OPEN
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_OPEN < cycle )
+if( DEBUG_VFS_OPEN < cycle )
 printk("\n[DBG] %s : thread %x exit for <%s> / file %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, path, GET_PTR(file_xp), GET_CXY(file_xp), cycle );
@@ -1365,7 +1365,7 @@
     process = this->process;
 
-#if CONFIG_DEBUG_VFS_LOOKUP
+#if DEBUG_VFS_LOOKUP
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : thread %x enter for <%s> / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, pathname, cycle );
@@ -1393,6 +1393,6 @@
         vfs_get_name_from_path( current , name , &next , &last );
 
-#if (CONFIG_DEBUG_VFS_LOOKUP & 1)
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+#if (DEBUG_VFS_LOOKUP & 1)
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : look for <%s> / last = %d\n", __FUNCTION__ , name , last );
 #endif
@@ -1414,6 +1414,6 @@
         {
 
-#if (CONFIG_DEBUG_VFS_LOOKUP & 1)
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+#if (DEBUG_VFS_LOOKUP & 1)
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : miss <%s> => load it\n", __FUNCTION__ , name );
 #endif
@@ -1500,6 +1500,6 @@
             vfs_inode_lock( parent_xp );
 
-#if (CONFIG_DEBUG_VFS_LOOKUP & 1)
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+#if (DEBUG_VFS_LOOKUP & 1)
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : created node <%s>\n", __FUNCTION__ , name );
 #endif
@@ -1507,6 +1507,6 @@
         }
 
-#if (CONFIG_DEBUG_VFS_LOOKUP & 1)
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+#if (DEBUG_VFS_LOOKUP & 1)
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : found <%s> / inode %x in cluster %x\n",
 __FUNCTION__ , name , GET_PTR(child_xp) , GET_CXY(child_xp) );
@@ -1536,7 +1536,7 @@
     vfs_inode_unlock( parent_xp );
 
-#if CONFIG_DEBUG_VFS_LOOKUP
+#if DEBUG_VFS_LOOKUP
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_LOOKUP < cycle )
+if( DEBUG_VFS_LOOKUP < cycle )
 printk("\n[DBG] %s : thread %x exit for <%s> / inode %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, pathname, GET_PTR(child_xp), GET_CXY(child_xp), cycle );
@@ -1639,7 +1639,7 @@
     parent_ptr = (vfs_inode_t *)GET_PTR( parent_xp );
 
-#if CONFIG_DEBUG_VFS_ADD_CHILD
+#if DEBUG_VFS_ADD_CHILD
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_ADD_CHILD < cycle )
+if( DEBUG_VFS_ADD_CHILD < cycle )
 printk("\n[DBG] %s : thread %x enter for <%s> / child_cxy = %x / parent_cxy = %x\n",
 __FUNCTION__ , CURRENT_THREAD , name , child_cxy , parent_cxy );
@@ -1654,6 +1654,6 @@
                                    &dentry_xp );
 
-#if (CONFIG_DEBUG_VFS_ADD_CHILD & 1)
-if( (CONFIG_DEBUG_VFS_ADD_CHILD < cycle) && (error == 0) )
+#if (DEBUG_VFS_ADD_CHILD & 1)
+if( (DEBUG_VFS_ADD_CHILD < cycle) && (error == 0) )
 printk("\n[DBG] %s : dentry <%s> created in cluster %x\n", __FUNCTION__, name, local_cxy );
 #endif
@@ -1669,6 +1669,6 @@
                                       &error );
 
-#if (CONFIG_DEBUG_VFS_ADD_CHILD & 1)
-if( (CONFIG_DEBUG_VFS_ADD_CHILD < cycle) && (error == 0) )
+#if (DEBUG_VFS_ADD_CHILD & 1)
+if( (DEBUG_VFS_ADD_CHILD < cycle) && (error == 0) )
 printk("\n[DBG] %s : dentry <%s> created in cluster %x\n", __FUNCTION__, name, parent_cxy );
 #endif
@@ -1701,6 +1701,6 @@
                                   &inode_xp );
 
-#if (CONFIG_DEBUG_VFS_ADD_CHILD & 1)
-if( CONFIG_DEBUG_VFS_ADD_CHILD < cycle )
+#if (DEBUG_VFS_ADD_CHILD & 1)
+if( DEBUG_VFS_ADD_CHILD < cycle )
 printk("\n[DBG] %s : inode <%x> created in cluster %x\n",
 __FUNCTION__ , GET_PTR(inode_xp) , local_cxy );
@@ -1722,6 +1722,6 @@
                                      &error );
 
-#if (CONFIG_DEBUG_VFS_ADD_CHILD & 1)
-if( CONFIG_DEBUG_VFS_ADD_CHILD < cycle )
+#if (DEBUG_VFS_ADD_CHILD & 1)
+if( DEBUG_VFS_ADD_CHILD < cycle )
 printk("\n[DBG] %s : inode <%s> created in cluster %x\n",
 __FUNCTION__ , GET_PTR(inode_xp) , child_cxy );
@@ -1746,7 +1746,7 @@
     hal_remote_swd( XPTR( dentry_cxy , &dentry_ptr->child_xp ) , inode_xp );
 
-#if CONFIG_DEBUG_VFS_ADD_CHILD
+#if DEBUG_VFS_ADD_CHILD
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_ADD_CHILD < cycle )
+if( DEBUG_VFS_ADD_CHILD < cycle )
 printk("\n[DBG] %s : thread %x exit for <%s>\n",
 __FUNCTION__ , CURRENT_THREAD , name );
@@ -1775,7 +1775,7 @@
     assert( (mapper != NULL) , __FUNCTION__ , "no mapper for page\n" );
 
-#if CONFIG_DEBUG_VFS_MAPPER_MOVE
+#if DEBUG_VFS_MAPPER_MOVE
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_MAPPER_MOVE < cycle )
+if( DEBUG_VFS_MAPPER_MOVE < cycle )
 printk("\n[DBG] %s : thread %x enter for page %d / mapper %x / inode %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, page->index, mapper, mapper->inode, cycle );
@@ -1805,7 +1805,7 @@
     }
 
-#if CONFIG_DEBUG_VFS_MAPPER_MOVE
+#if DEBUG_VFS_MAPPER_MOVE
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_MAPPER_MOVE < cycle )
+if( DEBUG_VFS_MAPPER_MOVE < cycle )
 printk("\n[DBG] %s : thread %x exit for page %d / mapper %x / inode %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, page->index, mapper, mapper->inode, cycle );
@@ -1829,7 +1829,7 @@
     assert( (mapper != NULL) , __FUNCTION__ , "mapper pointer is NULL\n" );
 
-#if CONFIG_DEBUG_VFS_MAPPER_LOAD
+#if DEBUG_VFS_MAPPER_LOAD
 uint32_t cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_MAPPER_MOVE < cycle )
+if( DEBUG_VFS_MAPPER_MOVE < cycle )
 printk("\n[DBG] %s : thread %x enter for inode %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, inode, local_cxy, cycle );
@@ -1850,7 +1850,7 @@
     }
 
-#if CONFIG_DEBUG_VFS_MAPPER_LOAD
+#if DEBUG_VFS_MAPPER_LOAD
 cycle = (uint32_t)hal_get_cycles();
-if( CONFIG_DEBUG_VFS_MAPPER_MOVE < cycle )
+if( DEBUG_VFS_MAPPER_MOVE < cycle )
 printk("\n[DBG] %s : thread %x exit for inode %x in cluster %x / cycle %d\n",
 __FUNCTION__, CURRENT_THREAD, inode, local_cxy, cycle );