Index: soft/giet_vm/giet_python/mapping.py
===================================================================
--- soft/giet_vm/giet_python/mapping.py	(revision 425)
+++ soft/giet_vm/giet_python/mapping.py	(revision 441)
@@ -19,5 +19,5 @@
 #                        a set of 'Task'      (user tasks mapping)
 # - A 'Vseg'   contains  a set of 'Vobj'
-# - A 'Periph' contains  a set of 'Irq'       (only for XCU, ICU and PIC types )
+# - A 'Periph' contains  a set of 'Irq'       (only for XCU and PIC types )
 # - A 'Coproc' contains  a set of 'Cpports'   (one port per MWMR channel)
 ##########################################################################################
@@ -54,5 +54,4 @@
                   'DMA',
                   'FBF',
-                  'ICU',
                   'IOB',
                   'IOC',
@@ -173,5 +172,5 @@
         self.x_size         = x_size
         self.y_size         = y_size
-        self.nprocs      = nprocs
+        self.nprocs         = nprocs
         self.x_width        = x_width
         self.y_width        = y_width
@@ -494,10 +493,5 @@
                  stackname,             # name of vobj containing stack
                  heapname,              # name of vobj containing heap
-                 startid,               # index in start_vector
-                 usetty = False,        # request a private TTY channel
-                 usenic = False,        # request a private NIC channel
-                 usecma = False,        # request a private CMA channel
-                 usehba = False,        # request a private HBA channel
-                 usetim = False ):      # request a private TIM channel
+                 startid ):             # index in start_vector
 
         assert (x < self.x_size) and (y < self.y_size)
@@ -505,6 +499,5 @@
 
         # add one task into mapping
-        task = Task( name, trdid, x, y, lpid, stackname, heapname, startid,
-                     usetty, usenic, usecma, usehba, usetim )
+        task = Task( name, trdid, x, y, lpid, stackname, heapname, startid )
         vspace.tasks.append( task )
         task.index = self.total_tasks
@@ -854,9 +847,4 @@
         seg_fbf_size = 0
 
-        nb_icu       = 0
-        icu_channels = 0
-        seg_icu_base = 0xFFFFFFFF
-        seg_icu_size = 0
-
         nb_iob       = 0
         iob_channels = 0
@@ -941,10 +929,4 @@
                     nb_fbf +=1
 
-                elif ( periph.ptype == 'ICU' ):
-                    seg_icu_base = periph.pseg.base & 0xFFFFFFFF
-                    seg_icu_size = periph.pseg.size
-                    icu_channels = periph.channels
-                    nb_icu +=1
-
                 elif ( periph.ptype == 'IOB' ):
                     seg_iob_base = periph.pseg.base & 0xFFFFFFFF
@@ -1019,7 +1001,4 @@
                     xcu_arg      = periph.arg
                     nb_xcu +=1
-
-        # don't mix ICU and XCU
-        assert ( nb_icu*nb_xcu == 0 )
 
         # no more than two access to external peripherals
@@ -1168,7 +1147,4 @@
         s += '#define SEG_FBF_BASE           0x%x\n'  % seg_fbf_base
         s += '#define SEG_FBF_SIZE           0x%x\n'  % seg_fbf_size
-        s += '\n'
-        s += '#define SEG_ICU_BASE           0x%x\n'  % seg_icu_base
-        s += '#define SEG_ICU_SIZE           0x%x\n'  % seg_icu_size
         s += '\n'
         s += '#define SEG_IOB_BASE           0x%x\n'  % seg_iob_base
@@ -1326,8 +1302,4 @@
                     s += '    reg = <0x%x  0x%x  0x%x>;\n' % (msb, lsb, size)
                     s += '  };\n\n'
-
-                # search ICU (non supported by Linux)
-                if ( periph.ptype == 'ICU' ):
-                    print '[genmap warning] in linux_dts() : ICU peripheral not supported by LINUX'
 
             # we need one interrupt controler in any cluster containing peripherals
@@ -1762,9 +1734,4 @@
                     sys.exit(1)
 
-                # research ICU component
-                elif ( periph.ptype == 'ICU' ):
-                    print '[genmap error] in netbsd_dts() : ICU peripheral not supported by NetBSD'
-                    sys.exit(1)
-
         # topology
         s += '\n'
@@ -2089,10 +2056,5 @@
                   stackname,
                   heapname,
-                  startid,
-                  usetty = False,
-                  usenic = False,
-                  usecma = False,
-                  usehba = False,
-                  usetim = False ):
+                  startid ):
 
         self.index     = 0             # global index value set by addTask()
@@ -2105,9 +2067,4 @@
         self.heapname  = heapname      # name of vobj containing the heap
         self.startid   = startid       # index in start_vector
-        self.usetty    = usetty        # request a private TTY channel
-        self.usenic    = usenic        # request a private NIC channel
-        self.usecma    = usecma        # request a private CMA channel
-        self.usehba    = usehba        # request a private HBA channel
-        self.usetim    = usetim        # request a private TIM channel
         return
 
@@ -2123,9 +2080,4 @@
         s += ' heapname="%s"'              % self.heapname
         s += ' startid="%d"'               % self.startid
-        if self.usetty != 0: s += ' usetty="1"'
-        if self.usenic != 0: s += ' usenic="1"'
-        if self.usecma != 0: s += ' usehba="1"'
-        if self.usehba != 0: s += ' usehba="1"'
-        if self.usetim != 0: s += ' usehba="1"'
         s += ' />\n'
 
@@ -2175,9 +2127,4 @@
         byte_stream += mapping.int2bytes( 4,  vobj_heap_id )    # heap vobj local index
         byte_stream += mapping.int2bytes( 4,  self.startid )    # index in start vector
-        byte_stream += mapping.int2bytes( 4,  self.usetty )     # TTY channel required
-        byte_stream += mapping.int2bytes( 4,  self.usenic )     # NIC channel required
-        byte_stream += mapping.int2bytes( 4,  self.usecma )     # CMA channel required
-        byte_stream += mapping.int2bytes( 4,  self.usehba )     # IOC channel required
-        byte_stream += mapping.int2bytes( 4,  self.usetim )     # TIM channel required
 
         if ( verbose ):
@@ -2501,5 +2448,5 @@
         s += ' channels="%d"'                % self.channels
         s += ' arg="%d" >\n'                 % self.arg
-        if ( (self.ptype == 'PIC') or (self.ptype == 'XCU') or (self.ptype == 'ICU') ):
+        if ( (self.ptype == 'PIC') or (self.ptype == 'XCU') ):
             for irq in self.irqs: s += irq.xml()
         s += '            </periph>\n'